# IMPORTED FROM RTSS09 then heavily modified

import os, pickle, sys, shutil, popen2
import cpu2000
from specprepare import ALL_BENCHMARKS, SP, CCSetup, On_Blacklist
from config import ROOT, M5_BIN

def Prepare_Task_Set():
    m5 = M5_BIN
    max_tick = 250e6
    root = ROOT
    assert os.path.exists(os.path.join(root, "stats"))
    CCSetup()

    all_benches = ALL_BENCHMARKS[:]
    all_benches.reverse()
    active = False
    done = set()
    task_set = dict()

    for (count, bench) in enumerate(all_benches):
        if ( bench.name in done ):
            continue
        if (On_Blacklist(bench)):
            continue

        done.add(bench.name)

        for instance in "12X":
            os.chdir(root)
            instance_dir = "scratch%s" % instance
            os.system("rm -rf %s" % instance_dir)
            os.mkdir(instance_dir)

        task_set[ bench.name ] = Prepare_Task(root, 
                count, bench, "r", m5, max_tick, "")

    return task_set

def Prepare_Task(root, count, bench, write_oracle, m5, max_tick, copy):
    input_set = 'ref'

    binary = os.path.join(
            cpu2000.spec_dist, "binaries",
            "alpha", "linux", bench.name)
    data_dir = os.path.join(
            cpu2000.spec_dist, "data",
            bench.name, input_set)
    input_dir = os.path.join(data_dir, "input")
    output_dir = os.path.join(data_dir, "output")
    expect_dir = os.path.join(data_dir, "expect")

    if ( not os.path.exists(binary + "1") ):
        assert 0, ("%s not found" % os.path.abspath(binary + "1"))
        return []

    bench_name = bench.name

    print 'preparing benchmark: ', bench_name

    control = []
    trace = []
    stats_file = "%s/stats/%s.m5" % (root, bench_name)
    subtask_list = []

    for instance in "21X":
        os.chdir(root)
        instance_dir = "scratch%s" % instance
        os.chdir(instance_dir)

        b = bench('alpha', 'linux', input_set)
        if ( instance == 'X' ):
            b.executable = binary + '1'
        else:
            b.executable = binary + instance

        print 'scratch:', instance_dir
        print 'binary:', b.executable
        params = {
                "bench" : b,
                "binary" : b.executable,
                "input_dir" : input_dir, 
                "output_dir" : output_dir, 
                "stats" : stats_file,
                "mt" : max_tick,
                "m5" : m5,
                "stdout" : "%s/stats/%s.out" % (root, bench_name),
                "stderr" : "%s/stats/%s.err" % (root, bench_name),
                "run_dir" : os.getcwd(),
                }
        if ( instance == "2" ):
            params[ 'stats' ] = "/dev/null"
            params[ 'stdout' ] = params[ 'stderr' ] = "/dev/null"

        subtask_list.append(params)

    os.chdir(root)
    return subtask_list


